


import java.net.*;
import java.io.*;
JSONArray values;
String result;
PFont f;

float Size = 10;


//Create mercator map object
MercatorMap mercatorMap;

//create PVector
PVector zone;



void setup() {


  size(displayWidth, displayHeight);
  smooth();
  frameRate(1);
  orientation(LANDSCAPE);

  textAlign(CENTER, CENTER);
  colorMode(HSB, 360);

  //load the image object
  //map = loadImage("map.png");

  //create the map/sketch coordinate translation
  mercatorMap = new MercatorMap(displayWidth, displayHeight, 75, -60, -180, 180);
}


void draw() {



  background(#101028);
  result   = getUrlContents("http://api.openweathermap.org/data/2.5/box/city?bbox=180,-60,-180,80,6&cluster=yesAPPID=cf2cb31da8ee6cb71a5270b0008cc4fb");
  JSONObject json = JSONObject.parse(result);
  JSONArray list = json.getJSONArray("list");
  //JSONArray weather = list.getJSONArray("weather");



  for (int i = 0; i < list.size (); i++) {
    JSONObject listItems = list.getJSONObject(i);
    JSONObject coord = listItems.getJSONObject("coord");
    String name = listItems.getString("name");
    Float lon = coord.getFloat("lon");
    Float lat = coord.getFloat("lat");
    JSONObject main = listItems.getJSONObject("main");
    Float temp = main.getFloat("temp");
    Float humidity = main.getFloat("humidity");
    Float pressure = main.getFloat("pressure");



    println(pressure);

    zone = mercatorMap.getScreenLocation(new PVector(lat, lon));

    float humid= map(humidity, 0, 100, 0, 255);

    float _temp = temp;
    if (_temp < -10) _temp = -10;
    if (_temp  > 30) _temp = 30;
    float hue = map(_temp, -10, 30, 240, 0);
    fill(hue, 300, 300, humidity+50);
    // fill(hue, 300, 300);

    ellipse(zone.x, zone.y, 20, 20);
    noStroke();
    fill(hue, 300, 300);
    ellipse(zone.x, zone.y, 5, 5);

    f = createFont("Arial", 16, true);
    textFont(f, 50);


    ArrayList<String> cities = new ArrayList<String>();
    // StringList cities;

    if (dist(mouseX, mouseY, zone.x, zone.y) < 15) {

      cities.add(name);
      println(cities.size());
      fill(hue, 300, 300, humidity+100);
      for (int j= 0; j < cities.size (); j++) {
        //text(cities.get(j) +" / Temp: "+temp+" C", width/2, (height/2)+(j*200));

        textFont(f, 50);
        textAlign(LEFT);
        fill(255);
        text("Pressure" + " "+pressure + " hpa ", 100, 50);
        fill(hue, 300, 300);
        text(" Temp: "+temp+" C", 100, 80);
        fill(hue, 300, 300, humid);
        ellipse(zone.x, zone.y, 150, 150);
        noStroke();
        fill(hue, 300, 300);
        ellipse(zone.x, zone.y, 20, 20);
        fill(255);
        textFont(f,40);
        text("Humidity" + " " + humidity + "%", mouseX, mouseY+ 50);
       
        textFont(f, 80);
        text(cities.get(j), mouseX+50, mouseY-100);
      }
      //   text(name +" "+temp+" "+hue, width/2, height/2);
    } else {
      //text("No Rollover", width/2, height/2);
      for (int j= 0; j < cities.size (); j++) {
        cities.remove(j);
      }
    }
  }
}


